### Feeling the Past

*Feeling the Past* is an interactive text-based educational game, which comments on the role of objects in the historical source selection. In the game the player, slipping into the role of a master's student doing an internship in a museum, is confronted with various tasks regarding objects and their role in historical research. The goal is illustrating that objects are an undervalued source group in historical research and a lot can be gained from using them as sources. For more discussion see the reflection piece [here](https://feeling-the-past.readthedocs.io/en/latest/).

For a view into the planning process at an early stage look at the file session-7.md, also found in this directory. 

The game is publically available and can be played on [*Lives in Transit*](https://livesintransit.org/login). 

The repository for the game is hosted on [GitHub](https://github.com/henokemp/lit-feelingthepast).



